#include "stdafx.h"
#include "VideoConverter.h"
#include "VideoConverterDlg.h"
#include "MediaInfoDll.h"
#include "myUtil.h"
#include "XReg.h"
#include "AboutDlg.h"
#include "Lang.h"
#include "BVLEncDec.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(disable: 4996)


#define VCODEC_MPEG _T("mpeg1video")
#define VCODEC_VP80 _T("libvpx")

CVideoConverterDlg::CVideoConverterDlg(DWORD idd, CWnd* pParent /*=NULL*/)
	: CDialog(idd, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_sDestPath = GetMyDocumentPath();
	InitOption();

	m_nOriginalVidW = 0;
	m_nOriginalVidH = 0;

	m_bConverting = FALSE;
	m_nEncodingMode = MODE_CBR;
}

void CVideoConverterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVideoConverterDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CVideoConverterDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CVideoConverterDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_FIND_SRCFILE, &CVideoConverterDlg::OnBnClickedButtonFindSrcfile)
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_BTN_START, &CVideoConverterDlg::OnBnClickedBtnStart)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_STOP, &CVideoConverterDlg::OnBnClickedBtnStop)
	ON_BN_CLICKED(IDC_CHK_VIDEO_CHANGE_SIZE, &CVideoConverterDlg::OnBnClickedChkVideoChangeSize)
	ON_BN_CLICKED(IDC_CHK_VIDEO_CHANGE_FPS, &CVideoConverterDlg::OnBnClickedChkVideoChangeFps)
	ON_BN_CLICKED(IDC_CHK_NO_AUDIO, &CVideoConverterDlg::OnBnClickedChkNoAudio)
	ON_BN_CLICKED(IDC_BUTTON_INIT, &CVideoConverterDlg::OnBnClickedButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_DSTPATH, &CVideoConverterDlg::OnBnClickedButtonOpenDstpath)
	ON_BN_CLICKED(IDC_BUTTON_FIND_DSTPATH2, &CVideoConverterDlg::OnBnClickedButtonFindDstpath)
	ON_BN_CLICKED(IDC_BTN_ABOUT, &CVideoConverterDlg::OnBnClickedBtnAbout)
	ON_BN_CLICKED(IDC_CHK_FILENAME_BITRATE, &CVideoConverterDlg::OnBnClickedChkFilenameBitrate)
	ON_BN_CLICKED(IDC_CHK_ENCRYPTION, &CVideoConverterDlg::OnBnClickedChkEncryption)
	ON_BN_CLICKED(IDC_CHK_2PASS, &CVideoConverterDlg::OnBnClickedChk2Pass)
	ON_BN_CLICKED(IDC_CHK_VBR, &CVideoConverterDlg::OnBnClickedChkVBR)
END_MESSAGE_MAP()


void CVideoConverterDlg::OnDestroy()
{
	ScreenToSetting();
	SaveSettings();
	__super::OnDestroy();
}

BOOL CVideoConverterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	::DragAcceptFiles(m_hWnd, TRUE);

	// ޽ â 
	CRect	rMessage;
	::GetWindowRect(::GetDlgItem(m_hWnd, IDC_STATIC_MESSAGE), &rMessage);
	ScreenToClient(&rMessage);
	m_messageCtrl.Create(::AfxGetInstanceHandle(), m_hWnd, rMessage.left, rMessage.top, rMessage.Width(), rMessage.Height());

	SetDlgItemText(IDC_EDIT_SRC_FILEINFO, LANG(LANGID_YOU_CAN_USE_DND));

	HWND	hWndCB;

	//  ũ
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_VIDEO_SIZE);
	ComboBox_AddString(hWndCB, _T("320x240"));
	ComboBox_AddString(hWndCB, _T("480x320"));
	ComboBox_AddString(hWndCB, _T("640x480"));
	ComboBox_AddString(hWndCB, _T("1024x768"));
	ComboBox_AddString(hWndCB, _T("800x450"));
	ComboBox_AddString(hWndCB, _T("1024x576"));
	ComboBox_AddString(hWndCB, _T("1280x720"));

	//  ƮƮ
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_VIDEO_BITRATE);
	ComboBox_AddString(hWndCB, _T("500"));
	ComboBox_AddString(hWndCB, _T("1000"));
	ComboBox_AddString(hWndCB, _T("1500"));
	ComboBox_AddString(hWndCB, _T("2000"));
	ComboBox_AddString(hWndCB, _T("3000"));
	ComboBox_AddString(hWndCB, _T("4000"));
	ComboBox_AddString(hWndCB, _T("5000"));
	ComboBox_AddString(hWndCB, _T("6000"));
	ComboBox_AddString(hWndCB, _T("7000"));
	ComboBox_AddString(hWndCB, _T("8000"));

	//  ǰ
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_VIDEO_QSCALE);
	ComboBox_AddString(hWndCB, _T("1"));
	ComboBox_AddString(hWndCB, _T("2"));
	ComboBox_AddString(hWndCB, _T("3"));
	ComboBox_AddString(hWndCB, _T("4"));
	ComboBox_AddString(hWndCB, _T("5"));
	ComboBox_AddString(hWndCB, _T("6"));
	ComboBox_AddString(hWndCB, _T("7"));
	ComboBox_AddString(hWndCB, _T("8"));
	ComboBox_AddString(hWndCB, _T("9"));
	ComboBox_AddString(hWndCB, _T("10"));
	ComboBox_AddString(hWndCB, _T("12"));
	ComboBox_AddString(hWndCB, _T("14"));
	ComboBox_AddString(hWndCB, _T("16"));
	ComboBox_AddString(hWndCB, _T("18"));
	ComboBox_AddString(hWndCB, _T("20"));
	ComboBox_AddString(hWndCB, _T("25"));
	ComboBox_AddString(hWndCB, _T("31"));

	//  ӷƮ
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_VIDEO_FPS);
	ComboBox_AddString(hWndCB, _T("24"));
	ComboBox_AddString(hWndCB, _T("30"));
	ComboBox_AddString(hWndCB, _T("60"));

	//  GOP
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_VIDEO_GOP);
	ComboBox_AddString(hWndCB, _T("30"));
	ComboBox_AddString(hWndCB, _T("60"));
	ComboBox_AddString(hWndCB, _T("120"));
	ComboBox_AddString(hWndCB, _T("180"));
	ComboBox_AddString(hWndCB, _T("240"));

	//  ä
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_AUDIO_CHANNEL);
	ComboBox_AddString(hWndCB, _T("1(mono)"));
	ComboBox_AddString(hWndCB, _T("2(stereo)"));


	//  ƮƮ
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_AUDIO_BITRATE);
	ComboBox_AddString(hWndCB, _T("64"));
	ComboBox_AddString(hWndCB, _T("96"));
	ComboBox_AddString(hWndCB, _T("128"));
	ComboBox_AddString(hWndCB, _T("160"));
	ComboBox_AddString(hWndCB, _T("192"));
	ComboBox_AddString(hWndCB, _T("256"));

	//  ÷Ʈ
	hWndCB = ::GetDlgItem(m_hWnd, IDC_CB_AUDIO_SAMPLERATE);
	ComboBox_AddString(hWndCB, _T("32000"));
	ComboBox_AddString(hWndCB, _T("44100"));
	ComboBox_AddString(hWndCB, _T("48000"));


	// ɼ б
	LoadSettings();
	SettingToScreen();
	EnableDisableControl();

	CString sText;
	GetWindowText(sText);
	sText += _T(" - ") + GetBuildDateStr();
	SetWindowText(sText);

#ifdef _DEBUG
	//OpenFile(_T("E:\\ \\metalrage_cg.wmv"));
#endif

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///          ʱȭ
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  5:54:45 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::InitOption()
{
	m_sVideoCodec = VCODEC_VP80;
	m_bVideoVBR = FALSE;

	m_bChangeVideoSize = FALSE;
	m_bChangeVideoFps = FALSE;
	m_nVideoBitrate = 4000;
	m_nVideoQscale = 8;
	m_nVideoGop = 120;
	m_nAudioBitrate = 128;
	m_nAudioSamplerate = 44100;
	m_nVideoFps = 30;
	m_sVideoSize = _T("640x480");
	m_sAudioChannel = _T("2(stereo)");
	m_bNoAudio = FALSE;

	m_bBitrateFilename = FALSE;
	m_bEncryption = FALSE;
	m_b2PassEncoding = TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          б
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  4:14:24 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::LoadSettings()
{
	XReg	reg;
	reg.Open(HKEY_CURRENT_USER, _T("Software\\VideoConverter"));


	//  
	reg.GetStr(_T("DestPath"), m_sDestPath, m_sDestPath);

	//  ڵ
	reg.GetStr(_T("VideoCodec"), m_sVideoCodec, m_sVideoCodec);

	//  VBR
	reg.GetInt(_T("VideoVBR"), m_bVideoVBR, m_bVideoVBR);

	//  ũ ȯ
	reg.GetInt(_T("ChangeVideoSize"), m_bChangeVideoSize, m_bChangeVideoSize);

	//  ũ
	reg.GetStr(_T("VideoSize"), m_sVideoSize, m_sVideoSize);

	//  ƮƮ
	reg.GetInt(_T("VideoBitrate"), m_nVideoBitrate, m_nVideoBitrate);

	//  ǰ
	reg.GetInt(_T("VideoQscale"), m_nVideoQscale, m_nVideoQscale);	

	//  FPS ȯ
	reg.GetInt(_T("ChangeVideoFps"), m_bChangeVideoFps, m_bChangeVideoFps);

	//  FPS
	reg.GetInt(_T("VideoFps"), m_nVideoFps, m_nVideoFps);

	//  GOP
	reg.GetInt(_T("VideoGop"), m_nVideoGop, m_nVideoGop);

	//  ƮƮ
	reg.GetInt(_T("AudioBitrate"), m_nAudioBitrate, m_nAudioBitrate);

	//  ÷Ʈ
	reg.GetInt(_T("AudioSamplerate"), m_nAudioSamplerate, m_nAudioSamplerate);

	//  ä
	reg.GetStr(_T("AudioChannel"), m_sAudioChannel, m_sAudioChannel);

	//   
	reg.GetInt(_T("NoAudio"), m_bNoAudio, m_bNoAudio);

	//  ̸ ƮƮ ǥ
	reg.GetInt(_T("BitrateFilename"), m_bBitrateFilename, m_bBitrateFilename);

	// ȣȭ AVX  
	reg.GetInt(_T("Encryption"), m_bEncryption, m_bEncryption);

	// 2PASS ڵ
	reg.GetInt(_T("2PassEncoding"), m_b2PassEncoding, m_b2PassEncoding);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///           ȭ Ʈѿ 
/// @param  
/// @return 
/// @date   Wednesday, December 17, 2008  11:17:07 AM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::SettingToScreen()
{
	//  
	SetDlgItemText(IDC_EDIT_DST_PATH, m_sDestPath);

	//  ڵ
	if(m_sVideoCodec == VCODEC_MPEG)
	{
		Button_SetCheck(::GetDlgItem(m_hWnd, IDC_RD_MPEG), TRUE);
		Button_SetCheck(::GetDlgItem(m_hWnd, IDC_RD_VP80), FALSE);
	}
	else if(m_sVideoCodec == VCODEC_VP80)
	{
		Button_SetCheck(::GetDlgItem(m_hWnd, IDC_RD_MPEG), FALSE);
		Button_SetCheck(::GetDlgItem(m_hWnd, IDC_RD_VP80), TRUE);
	}
	else 
	{
		ASSERT(0);
		Button_SetCheck(::GetDlgItem(m_hWnd, IDC_RD_MPEG), TRUE);
		Button_SetCheck(::GetDlgItem(m_hWnd, IDC_RD_VP80), FALSE);
	}

	//  ũ ȯ
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VIDEO_CHANGE_SIZE), m_bChangeVideoSize);

	//  ũ
	SetDlgItemText(IDC_CB_VIDEO_SIZE, m_sVideoSize);

	//  ƮƮ
	SetDlgItemInt(IDC_CB_VIDEO_BITRATE, m_nVideoBitrate);

	//  ǰ
	SetDlgItemInt(IDC_CB_VIDEO_QSCALE, m_nVideoQscale);

	//  FPS ȯ
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VIDEO_CHANGE_FPS), m_bChangeVideoFps);

	//  FPS
	SetDlgItemInt(IDC_CB_VIDEO_FPS, m_nVideoFps);

	//  GOP
	SetDlgItemInt(IDC_CB_VIDEO_GOP, m_nVideoGop);

	//  ƮƮ
	SetDlgItemInt(IDC_CB_AUDIO_BITRATE, m_nAudioBitrate);

	//  ÷Ʈ
	SetDlgItemInt(IDC_CB_AUDIO_SAMPLERATE, m_nAudioSamplerate);

	//  ä
	ComboBox_SelectString(::GetDlgItem(m_hWnd, IDC_CB_AUDIO_CHANNEL), -1, m_sAudioChannel);

	//   
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_NO_AUDIO), m_bNoAudio);

	//  ̸ ƮƮ ǥ
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_FILENAME_BITRATE), m_bBitrateFilename);

	// ȣȭ AVX  
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_ENCRYPTION), m_bEncryption);

	// 2PASS ڵ
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_2PASS), m_b2PassEncoding);

	//  VBR
	Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VBR), m_bVideoVBR);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  4:14:20 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::SaveSettings()
{
	XReg	reg;
	reg.Open(HKEY_CURRENT_USER, _T("Software\\VideoConverter"));

	//  
	reg.SetStr(_T("DestPath"), m_sDestPath);

	//  ڵ
	reg.SetStr(_T("VideoCodec"), m_sVideoCodec);

	//  VBR
	reg.SetInt(_T("VideoVBR"), m_bVideoVBR);

	//  ũ ȯ
	reg.SetInt(_T("ChangeVideoSize"),  m_bChangeVideoSize);

	//  ũ
	reg.SetStr(_T("VideoSize"), m_sVideoSize);

	//  ƮƮ
	reg.SetInt(_T("VideoBitrate"), m_nVideoBitrate);

	//  ǰ
	reg.SetInt(_T("VideoQscale"), m_nVideoQscale);	

	//  FPS ȯ
	reg.SetInt(_T("ChangeVideoFps"),  m_bChangeVideoFps);

	//  ӷƮ
	reg.SetInt(_T("VideoFps"), m_nVideoFps);

	//  GOP
	reg.SetInt(_T("VideoGop"), m_nVideoGop);

	//  ƮƮ
	reg.SetInt(_T("AudioBitrate"), m_nAudioBitrate);

	//  ÷Ʈ
	reg.GetInt(_T("AudioSamplerate"), m_nAudioSamplerate);

	//  ä
	reg.GetStr(_T("AudioChannel"), m_sAudioChannel);

	//   
	reg.SetInt(_T("NoAudio"), m_bNoAudio);

	//  ̸ ƮƮ ǥ
	reg.SetInt(_T("BitrateFilename"), m_bBitrateFilename);

	// ȣȭ AVX  
	reg.SetInt(_T("Encryption"), m_bEncryption);

	// 2PASS ڵ
	reg.SetInt(_T("2PassEncoding"), m_b2PassEncoding);
}

void CVideoConverterDlg::ScreenToSetting()
{
	//  
	GetDlgItemText(IDC_EDIT_DST_PATH, m_sDestPath);

	//  ڵ
	if(Button_GetCheck(::GetDlgItem(m_hWnd, IDC_RD_MPEG)))
		m_sVideoCodec = VCODEC_MPEG;
	else if(Button_GetCheck(::GetDlgItem(m_hWnd, IDC_RD_VP80)))
		m_sVideoCodec = VCODEC_VP80;
	else 
		ASSERT(0);

	//  ũ ȯ
	m_bChangeVideoSize = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VIDEO_CHANGE_SIZE));

	//  ũ
	GetDlgItemText(IDC_CB_VIDEO_SIZE, m_sVideoSize);

	//  ƮƮ
	m_nVideoBitrate = GetDlgItemInt(IDC_CB_VIDEO_BITRATE);

	//  ǰ
	m_nVideoQscale = GetDlgItemInt(IDC_CB_VIDEO_QSCALE);

	//  FPS ȯ
	m_bChangeVideoFps = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VIDEO_CHANGE_FPS));

	//  FPS
	m_nVideoFps = GetDlgItemInt(IDC_CB_VIDEO_FPS);

	//  GOP
	m_nVideoGop = GetDlgItemInt(IDC_CB_VIDEO_GOP);

	//  ƮƮ
	m_nAudioBitrate = GetDlgItemInt(IDC_CB_AUDIO_BITRATE);

	//  ÷Ʈ
	m_nAudioSamplerate = GetDlgItemInt(IDC_CB_AUDIO_SAMPLERATE);

	//  ä
	GetDlgItemText(IDC_CB_AUDIO_CHANNEL, m_sAudioChannel);

	//   
	m_bNoAudio = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_NO_AUDIO));

	//  ̸ ƮƮ ǥ
	m_bBitrateFilename = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_FILENAME_BITRATE));

	// ȣȭ AVX  
	m_bEncryption = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_ENCRYPTION));

	// 2PASS ڵ
	m_b2PassEncoding = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_2PASS));

	//  VBR
	m_bVideoVBR = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VBR));
}


// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CVideoConverterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CVideoConverterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CVideoConverterDlg::OnBnClickedOk()
{
//	OnOK();
}

void CVideoConverterDlg::OnBnClickedCancel()
{
	if(m_bConverting)
	{
		MessageBox(LANG(LANGID_CONVERTING));
		return;
	}

	OnCancel();
}



////////////////////////////////////////////////////////////////////////////////////////////////////
///           ã
/// @param  
/// @return 
/// @date   Monday, December 01, 2008  4:25:46 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnBnClickedButtonFindSrcfile()
{
	CFileDialog dlg(TRUE);
	if(dlg.DoModal()!=IDOK) return;

	OpenFile(dlg.GetPathName());

}



////////////////////////////////////////////////////////////////////////////////////////////////////
///          巡& ó
/// @param  
/// @return 
/// @date   Monday, December 01, 2008  4:26:32 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnDropFiles(HDROP hDropInfo)
{
	TCHAR	szFileName[_MAX_PATH];

	::DragQueryFile(hDropInfo, 0, szFileName, _MAX_PATH);
	::DragFinish(hDropInfo);
	OpenFile(szFileName);
}



////////////////////////////////////////////////////////////////////////////////////////////////////
///          
/// @param  
/// @return 
/// @date   Monday, December 01, 2008  4:27:42 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
using namespace MediaInfoLib;
MediaInfo MI;
BOOL CVideoConverterDlg::OpenFile(CString sSrcFileName)
{
	SetDlgItemText(IDC_EDIT_SRC_PATH_NAME, sSrcFileName);


	if(MI.Open((LPCTSTR)sSrcFileName)==FALSE)
	{
		MessageLn(LANG(LANGID_CANT_OPEN_FILE), sSrcFileName);
		SetDlgItemText(IDC_EDIT_SRC_FILEINFO, LANG(LANGID_UNKNOWN_FILE_FORMAT));
		ASSERT(0); return FALSE;
	}

	int		width;
	int		height;
	int		timeSec;
	CString	sVideoCodec;
	int		nVideoBitrate;

	CString	sAudioCodec;
	int		nAudioCodec=0;
	int		channels;
	int		nAudioBitrate;
	CString	temp;

	// video
	width = _ttoi(MI.Get(Stream_Video, 0, _T("Width"), Info_Text).c_str());
	height = _ttoi(MI.Get(Stream_Video, 0, _T("Height"), Info_Text).c_str());
	sVideoCodec = MI.Get(Stream_Video, 0, _T("Codec"), Info_Text).c_str();
	nVideoBitrate = _ttoi(MI.Get(Stream_Video, 0, _T("Bitrate"), Info_Text).c_str());

	// save video size
	m_nOriginalVidW = width;
	m_nOriginalVidH = height;


	// audio
	temp = MI.Get(Stream_Audio, 0, _T("Codec"), Info_Text).c_str();
	_stscanf(temp, _T("%x"), &nAudioCodec);
	if(nAudioCodec==0 || temp==_T("AC3") || temp==_T("A_AC3") || temp==_T("AAC"))
		sAudioCodec = temp;
	else
		sAudioCodec = WaveFormatTag2Str(nAudioCodec);

	channels = _ttoi(MI.Get(Stream_Audio, 0, _T("Channels"), Info_Text).c_str());
	nAudioBitrate = _ttoi(MI.Get(Stream_Audio, 0, _T("Bitrate"), Info_Text).c_str());

	// general
	timeSec = _ttoi(MI.Get(Stream_General, 0, _T("PlayTime"), Info_Text).c_str()) / 1000;


	CString str;
	str.Format(
		LANG(LANGID_VIDEO_INFO),

		width, height,
		sVideoCodec,
		nVideoBitrate/1000,


		sAudioCodec,
		channels,
		nAudioBitrate/1000,
		timeSec);

	SetDlgItemText(IDC_EDIT_SRC_FILEINFO, str);

	MessageLn(LANG(LANGID_OPEN_SUCCESS), sSrcFileName);

	MI.Close();


	return TRUE;
}



////////////////////////////////////////////////////////////////////////////////////////////////////
///         ȯ  ư
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  12:38:32 PM
////////////////////////////////////////////////////////////////////////////////////////////////////

#define EXE_PATH_NAME				_T("${EXE_PATH_NAME}")
#define INPUTFILE_PATH_NAME			_T("${INPUTFILE_PATH_NAME}")
#define OUTPUTFILE_PATH_NAME		_T("${OUTPUTFILE_PATH_NAME}")
#define VIDEO_CODEC					_T("${VIDEO_CODEC}")
#define VIDEO_TAG					_T("${VIDEO_TAG}")
#define VIDEO_BITRATE				_T("${VIDEO_BITRATE}")
#define VIDEO_QSCALE				_T("${VIDEO_QSCALE}")
#define VIDEO_FRAMERATE				_T("${VIDEO_FRAMERATE}")
#define VIDEO_SIZE					_T("${VIDEO_SIZE}")
#define VIDEO_GOP					_T("${VIDEO_GOP}")

#define AUDIO_BITRATE				_T("${AUDIO_BITRATE}")
#define AUDIO_CHANNEL				_T("${AUDIO_CHANNEL}")
#define AUDIO_SAMPLERATE			_T("${AUDIO_SAMPLERATE}")

#define PASS_NUM					_T("${PASS_NUM}")
#define PASS_LOGFILE_PATH_NAME		_T("${PASS_LOGFILE_PATH_NAME}")

#define	QUOT						_T("\"")

//#define _MPEG4


CString CVideoConverterDlg::GetEncoderCmdline(int nEncodingMode)
{
#ifdef _MPEG4
	CString sParam = _T("${EXE_PATH_NAME} -y -i ${INPUTFILE_PATH_NAME} -vcodec mpeg4 -bf 2 -aspect 1 -b ${VIDEO_BITRATE} ");
	CString sVideoSizeParam = _T("-s ${VIDEO_SIZE} -sws_flags lanczos+accurate_rnd ");
	CString sVideoFpsParam = _T("-r ${VIDEO_FRAMERATE} ");
	CString sVideoGopParam = _T("-g ${VIDEO_GOP} ");
	CString sAudioParam = _T("-acodec mp2 -ac ${AUDIO_CHANNEL} -ar ${AUDIO_SAMPLERATE} -ab ${AUDIO_BITRATE} ");
	CString sPassParam = _T("-pass ${PASS_NUM} -passlogfile ${PASS_LOGFILE_PATH_NAME} -g 120 ");
	CString sNoAudioParam = _T("-an ");
	CString	sFFMpegPathName = GetThisPath() + _T("ffmpeg.exe");
	CString sExt = _T(".avi");
#else
//	CString sParam = _T("${EXE_PATH_NAME} -y -i ${INPUTFILE_PATH_NAME} -vcodec mpeg1video -vtag MPEG -aspect 1 -b ${VIDEO_BITRATE} ");
	CString sParam = _T("${EXE_PATH_NAME} -y -i ${INPUTFILE_PATH_NAME} -vcodec ${VIDEO_CODEC} -vtag ${VIDEO_TAG} -aspect 1 ");
	CString sVideoBitrateParam = _T("-b ${VIDEO_BITRATE} ");
	CString sVideoQscaleParam = _T("-qmin ${VIDEO_QSCALE} -qmax ${VIDEO_QSCALE} ");
	//CString sVideoQscaleParam = _T("-qscale ${VIDEO_QSCALE} -qmin ${VIDEO_QSCALE} -qmax ${VIDEO_QSCALE} ");
	CString sVideoSizeParam = _T("-s ${VIDEO_SIZE} -sws_flags lanczos ");
	CString sVideoFpsParam = _T("-r ${VIDEO_FRAMERATE} ");
	CString sVideoGopParam = _T("-g ${VIDEO_GOP} ");
	CString sAudioParam = _T("-acodec mp2 -ac ${AUDIO_CHANNEL} -ar ${AUDIO_SAMPLERATE} -ab ${AUDIO_BITRATE} ");
//	CString sPassParam = _T("-pass ${PASS_NUM} -passlogfile ${PASS_LOGFILE_PATH_NAME} ");
	CString sPassParam = _T("-pass ${PASS_NUM} ");
	CString sNoAudioParam = _T("-an ");
	CString	sFFMpegPathName = GetThisPath() + _T("ffmpeg.exe");
	CString sExt = _T(".avi");
#endif

	CString	sInputPathName;
	CString	sOutputPathName;
	CString sVideoCodec;
	CString sVideoTag;
	CString	sVideoBitrate;
	CString	sVideoQscale;
	CString	sVideoFramerate;
	CString	sVideoGop;
	CString	sAudioBitrate;
	CString	sAudioChannel;
	CString	sAudioSamplerate;
	CString	sPassNum;
	CString	sPassLogFilePathName;

	TCHAR	fname[_MAX_FNAME];

	////////////////////////////////////////////////////////////////////////////////////////////////
	// ⺻  

	// ϸ ϸ 
	GetDlgItemText(IDC_EDIT_SRC_PATH_NAME, sInputPathName);
	_tsplitpath_s(sInputPathName, NULL, 0, NULL, 0, fname, _MAX_FNAME, NULL, 0 );

	//  ̸ 
	sOutputPathName = m_sDestPath;
	if(sOutputPathName.Right(1)!=_T("\\"))  sOutputPathName+= _T("\\");
	sOutputPathName = sOutputPathName + _T("[out] ") + fname;

	if(m_bBitrateFilename)
	{
		CString bitrate;
		bitrate.Format(_T("%dk"), m_nVideoBitrate);
		sOutputPathName += _T("_") + bitrate;
	}

	m_sFileName = sOutputPathName;
	sOutputPathName += sExt;

	// video codec
	sVideoCodec = m_sVideoCodec;

	if(m_sVideoCodec == VCODEC_MPEG)
		sVideoTag = _T("MPG1");
	else if(m_sVideoCodec == VCODEC_VP80)
		sVideoTag = _T("VP80");
	else
		ASSERT(0);

	// video bitrate
	sVideoBitrate.Format(_T("%d"), m_nVideoBitrate*1000);			// kb to bit

	// video qscale
	sVideoQscale.Format(_T("%d"), m_nVideoQscale);

	// video frame rate
	sVideoFramerate.Format(_T("%d"), m_nVideoFps);

	sVideoGop.Format(_T("%d"), m_nVideoGop);

	// audio bitrate
	sAudioBitrate.Format(_T("%dk"), m_nAudioBitrate);			// kb to bit

	// audio channel
	sAudioChannel.Format(_T("%d"), _ttoi(m_sAudioChannel));

	// audio samplerate
	sAudioSamplerate.Format(_T("%d"), m_nAudioSamplerate);

	// pass number
	sPassNum.Format(_T("%d"), nEncodingMode-MODE_VBR);

	// pass logfile pathname
	sPassLogFilePathName = m_sDestPath;
	if(sPassLogFilePathName.Right(1)!=_T("\\"))  sPassLogFilePathName+= _T("\\");
	sPassLogFilePathName += CString(fname);

	// ⺻  
	////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////////////////////
	// Ķ 

	if(m_bVideoVBR)
		sParam += sVideoQscaleParam;
	else
		

	//if(m_bChangeVideoSize)
		sParam += sVideoSizeParam;

	if(m_bChangeVideoFps)
		sParam += sVideoFpsParam;

	sParam += sVideoGopParam;

	if(nEncodingMode == MODE_VBR)
	{
		sParam += sVideoQscaleParam;

		if(m_bNoAudio)
			sParam += sNoAudioParam;
		else
			sParam += sAudioParam;
	}
	else if(nEncodingMode == MODE_PASS_1)
	{
		sParam += sVideoBitrateParam;
		sParam += sPassParam;
		sParam += sNoAudioParam;

	}
	else if(nEncodingMode == MODE_PASS_2)
	{
		sParam += sVideoBitrateParam;
		sParam += sPassParam;

		if(m_bNoAudio)
			sParam += sNoAudioParam;
		else
			sParam += sAudioParam;
	}
	else
	{
		// nEncodingMode == MODE_CBR
		sParam += sVideoBitrateParam;

		if(m_bNoAudio)
			sParam += sNoAudioParam;
		else
			sParam += sAudioParam;
	}


	// Ķ  Էϱ
	sParam.Replace(EXE_PATH_NAME,			QUOT + sFFMpegPathName + QUOT);
	sParam.Replace(INPUTFILE_PATH_NAME,		QUOT + sInputPathName  + QUOT);

	sParam.Replace(VIDEO_CODEC,				sVideoCodec);
	sParam.Replace(VIDEO_TAG,				sVideoTag);
	sParam.Replace(VIDEO_BITRATE,			sVideoBitrate);
	sParam.Replace(VIDEO_QSCALE,			sVideoQscale);
	sParam.Replace(VIDEO_FRAMERATE,			sVideoFramerate);
	sParam.Replace(VIDEO_GOP,				sVideoGop);

	sParam.Replace(AUDIO_BITRATE,			sAudioBitrate);
	sParam.Replace(AUDIO_CHANNEL,			sAudioChannel);
	sParam.Replace(AUDIO_SAMPLERATE,		sAudioSamplerate);

	sParam.Replace(PASS_NUM,				sPassNum);
	sParam.Replace(PASS_LOGFILE_PATH_NAME,	QUOT + sPassLogFilePathName + QUOT);
	
	if(m_bChangeVideoSize)
		sParam.Replace(VIDEO_SIZE,				m_sVideoSize);
	else	
	{
		// video size ٲ  -  ũ Ѵ.
		CString str;
		str.Format(_T("%dx%d"), m_nOriginalVidW, m_nOriginalVidH);
		sParam.Replace(VIDEO_SIZE,				str);
	}

	// ߰ 
	CString str;
	GetDlgItemText(IDC_EDIT_CMDLINE_IN, str);
	sParam += _T(" ") + str + _T(" ");

	//  ϸ
//	if(nEncodingMode != MODE_PASS_1)
	{
		sParam += QUOT + sOutputPathName + QUOT;
	}
//	else
	{
//		sParam += _T("NUL");
	}

	return sParam;
}


void CVideoConverterDlg::OnBnClickedBtnStart()
{
	ScreenToSetting();

	// ڵ  
	m_nEncodingMode = (m_bVideoVBR ? MODE_VBR : (m_b2PassEncoding ? MODE_PASS_1 : MODE_CBR));

	CString sCmdline = GetEncoderCmdline(m_nEncodingMode);
	
	SetDlgItemText(IDC_EDIT_CMDLINE, sCmdline);
	if(StartChildProcess(sCmdline, FALSE)==FALSE)
	{
		MessageLn(LANG(LANGID_CONVERT_FAILED));
		return;
	}

	MessageLn(LANG(LANGID_CONVERT_START));
}

void CVideoConverterDlg::OnBnClickedBtnStop()
{
	m_nEncodingMode = MODE_CBR;

	TerminateChildProcess();
	MessageLn(LANG(LANGID_CONVERT_STOP));
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///         CRedirect 
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  1:38:10 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnChildStarted(LPCTSTR lpszCmdLine)
{
	m_bConverting = TRUE;

	EnableDisableControl();
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///         CRedirect 
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  1:38:13 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnChildStdOutWrite(LPCSTR lpszOutput)
{
	Message(_T("%s"), lpszOutput);
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///         CRedirect 
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  1:38:18 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnChildStdErrWrite(LPCSTR lpszOutput)
{
	CString str;
	str = lpszOutput;
	Message(_T("%s"), str);
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///         CRedirect 
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  1:38:21 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnChildTerminate()
{
	// 1PASS ڵ .
	if(m_nEncodingMode == MODE_PASS_1)
	{
		m_nEncodingMode = MODE_PASS_2;

		CString sCmdline = GetEncoderCmdline(m_nEncodingMode);
		
		SetDlgItemText(IDC_EDIT_CMDLINE, sCmdline);
		if(StartChildProcess(sCmdline, FALSE)==FALSE)
		{
			MessageLn(LANG(LANGID_CONVERT_FAILED));
			return;
		}

		return;
	}
	else if(m_nEncodingMode == MODE_PASS_2)
	{
		// 2PASS α  
		TCHAR	fname[_MAX_FNAME];
		CString sInputPathName;
		CString sLogFolder;
		
		// ϸ ϸ 
		GetDlgItemText(IDC_EDIT_SRC_PATH_NAME, sInputPathName);
		_tsplitpath_s(sInputPathName, NULL, 0, NULL, 0, fname, _MAX_FNAME, NULL, 0 );
		sLogFolder = m_sDestPath;
		if(sLogFolder.Right(1)!=_T("\\"))  sLogFolder+= _T("\\");
		
		DeleteFile(sLogFolder + fname + _T("-0.log"));
		DeleteFile(sLogFolder + fname + _T("-1.log"));
	}

	m_bConverting = FALSE;

	if(m_bEncryption)
	{
		BVLEncDec	enc(m_sFileName);
		enc.Encode();
	}

	EnableDisableControl();

	MessageLn(LANG(LANGID_CONVERT_DONE));
}




////////////////////////////////////////////////////////////////////////////////////////////////////
///         ޽ 
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  2:02:03 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::MessageLn(LPCTSTR szMsg, ...)
{
	CString sMsg;
	va_list args;
	va_start(args, szMsg);
	sMsg.FormatV(szMsg, args);
	va_end(args);

	if(m_messageCtrl.GetWindowTextLengthW()==0)
		Message(_T("%s"), sMsg);
	else
		Message(_T("\r\n%s"), sMsg);
}

void CVideoConverterDlg::Message(LPCTSTR szMsg, ...)
{
	CString sMsg;
	va_list args;
	va_start(args, szMsg);
	sMsg.FormatV(szMsg, args);
	va_end(args);

	m_messageCtrl.AddFormatText(sMsg);
	m_messageCtrl.SetDefaultColor();
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///         control enable / disable
/// @param  
/// @return 
/// @date   Tuesday, December 16, 2008  3:53:14 PM
////////////////////////////////////////////////////////////////////////////////////////////////////
#define ENABLE(x, y)  ::EnableWindow(::GetDlgItem(m_hWnd, x), y);
void CVideoConverterDlg::EnableDisableControl()
{
	// / ư
	ENABLE(IDC_BTN_START,		!m_bConverting);
	ENABLE(IDC_BTN_STOP,		m_bConverting);

	//  ƮƮ
	ENABLE(IDC_CB_VIDEO_BITRATE,	!m_bVideoVBR);

	//  ǰ
	ENABLE(IDC_CB_VIDEO_QSCALE,	m_bVideoVBR);
	
	//  2н
	ENABLE(IDC_CHK_2PASS,		!m_bVideoVBR);

	//  ȯ
	ENABLE(IDC_CB_VIDEO_SIZE,	m_bChangeVideoSize);

	//  FPS
	ENABLE(IDC_CB_VIDEO_FPS,	m_bChangeVideoFps);

	//  ȯ 
	if(!m_bConverting)
	{
		ENABLE(IDC_CB_AUDIO_BITRATE,	!m_bNoAudio);
		ENABLE(IDC_CB_AUDIO_SAMPLERATE, !m_bNoAudio);
		ENABLE(IDC_CB_AUDIO_CHANNEL,	!m_bNoAudio);
	}
}

void CVideoConverterDlg::OnBnClickedChkVBR()
{
	m_bVideoVBR = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VBR));
	EnableDisableControl();
}

void CVideoConverterDlg::OnBnClickedChkVideoChangeSize()
{
	m_bChangeVideoSize = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VIDEO_CHANGE_SIZE));
	EnableDisableControl();
}


void CVideoConverterDlg::OnBnClickedChkVideoChangeFps()
{
	m_bChangeVideoFps = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_VIDEO_CHANGE_FPS));
	EnableDisableControl();
}


void CVideoConverterDlg::OnBnClickedChkNoAudio()
{
	m_bNoAudio = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_NO_AUDIO));
	EnableDisableControl();
}



////////////////////////////////////////////////////////////////////////////////////////////////////
///         ʱȭ
/// @param  
/// @return 
/// @date   Wednesday, December 17, 2008  11:14:48 AM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnBnClickedButtonInit()
{
	InitOption();
	EnableDisableControl();
	SettingToScreen();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///           
/// @param  
/// @return 
/// @date   Wednesday, December 17, 2008  11:28:25 AM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnBnClickedButtonOpenDstpath()
{
	ScreenToSetting();
	::ShellExecute(NULL, _T("open"), m_sDestPath, NULL, NULL, SW_SHOW);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///           
/// @param  
/// @return 
/// @date   Wednesday, December 17, 2008  11:42:52 AM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnBnClickedButtonFindDstpath()
{
	ScreenToSetting();

	CString str = GetDirectory(m_hWnd, m_sDestPath, LANG(LANGID_SELECT_TARGETFOLDER));

	if(str.IsEmpty()) return;
	SetDlgItemText(IDC_EDIT_DST_PATH, str);
}

void CVideoConverterDlg::OnBnClickedBtnAbout()
{
	CAboutDlg dlg;
	dlg.DoModal();
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///         ϸ ƮƮ  ǥ
/// @param  
/// @return 
/// @date   Monday, January 12, 2009  10:57:27 AM
////////////////////////////////////////////////////////////////////////////////////////////////////
void CVideoConverterDlg::OnBnClickedChkFilenameBitrate()
{
	m_bBitrateFilename = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_FILENAME_BITRATE) );
}


void CVideoConverterDlg::OnBnClickedChkEncryption()
{
	m_bEncryption = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_ENCRYPTION) );
}


void CVideoConverterDlg::OnBnClickedChk2Pass()
{
	m_b2PassEncoding = Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHK_2PASS) );
}
