////////////////////////////////////////////////////////////////////////////////////////////////////
/// 
/// read and write registry
/// 
/// @author   parkkh
/// @date     Tuesday, April 22, 2008  12:07:59 AM
/// 
////////////////////////////////////////////////////////////////////////////////////////////////////


#pragma once

class XReg
{
public :
	XReg();
	~XReg();

	BOOL	Open(HKEY hParentKey, LPCTSTR szSubKeyName, REGSAM samDesired=KEY_READ | KEY_WRITE, BOOL bCreateIfNotExist=TRUE);	// KEY_READ, KEY_WRITE, KEY_ALL_ACCESS
	BOOL	Create(HKEY hParentKey, LPCTSTR szSubKeyName, REGSAM samDesired=KEY_READ | KEY_WRITE);
	void	Close();
	BOOL	IsOpened() { return m_hKey ? TRUE : FALSE; }

	BOOL	GetStr(LPCTSTR szValueName, CString& sResult, LPCTSTR szDefaultValue=NULL);
	BOOL	GetDefaultValue(CString& sResult) { return GetStr(_T(""), sResult); }
	BOOL	GetInt(LPCTSTR szValueName, int& nResult, int nDefaultValue=0);
	BOOL	GetDWORD(LPCTSTR szValueName, DWORD& dwResult, DWORD dwDefaultValue=0);
	BOOL	GetBin(LPCTSTR szValueName, BYTE* pRetBuf, int nBufSize);
	BOOL	GetBinAlloc(LPCTSTR szValueName, BYTE** pRetBuf, int& nBufSize);

	BOOL	SetDefaultValue(LPCTSTR szValue) { return SetStr(_T(""), szValue); }
	BOOL	SetStr(LPCTSTR szValueName, LPCTSTR szValue);
	BOOL	SetStrW(LPCTSTR szValueName, LPCWSTR szValue);
	BOOL	SetBin(LPCTSTR szValueName, void* pData, int nDataLen);
	BOOL	SetInt(LPCTSTR szValueName, int nValue);
	BOOL	SetDWORD(LPCTSTR szValueName, DWORD dwValue);

	BOOL	DeleteCurrentKey() { return RecurseDeleteKey(_T("")); }
	BOOL	DeleteSubKey(LPCTSTR subKeyName);
	BOOL	RecurseDeleteKey(LPCTSTR subKeyName);

	BOOL	DeleteValue(LPCTSTR szValueName);
	BOOL	DeleteDefaultValue() { return DeleteValue(_T("")); }

	operator HKEY() { return m_hKey; }


private :
	HKEY	m_hKey;



};

