////////////////////////////////////////////////////////////////////////////////////////////////////
/// 
/// rich edit control capsulated window class
/// 
/// @author   park
/// @date     Monday, March 24, 2008  1:38:50 AM
/// 
////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

class XRichEditCtrl
{
public:
	XRichEditCtrl(void);
	~XRichEditCtrl(void);

	BOOL		Create(HINSTANCE hInstance, HWND hWndParent, int x, int y,  int width, int height);
	void		Test();
	void		AddText(CString strText);
	void		AddFormatText(CString sText);
	void		AddFormatTextLn(CString sText);

	void		SetSize(int nSize);
	void		SetBold(BOOL bBold);
	void		SetTextColor(COLORREF clr);
	void		SetDefaultColor();

	int			GetWindowTextLength();
	void		SetSel(long nStartChar, long nEndChar);

	void		HideSelection(BOOL bHide, BOOL bPerm) {ASSERT(::IsWindow(m_hWnd)); ::SendMessage(m_hWnd, EM_HIDESELECTION, bHide, bPerm); }
	void		ReplaceSel(LPCTSTR lpszNewText, BOOL bCanUndo=FALSE) {ASSERT(::IsWindow(m_hWnd)); ::SendMessage(m_hWnd, EM_REPLACESEL, (WPARAM) bCanUndo, (LPARAM)lpszNewText); }

	BOOL		SetSelectionCharFormat(CHARFORMAT &cf);

private :
	HWND		m_hWnd;
	HFONT		m_hFont;
	COLORREF	m_clrDefault;

};
