#include "stdafx.h"
#include "myUtil.h"

CString  GetThisPath()
{
	static TCHAR szModuleName[MAX_PATH*4];
	static BOOL bIsFirst = TRUE;
	if(bIsFirst)
	{
		::GetModuleFileName(NULL,szModuleName,MAX_PATH*4);
		*(_tcsrchr( szModuleName, '\\' ) + 1) = NULL;
		bIsFirst = FALSE;
	}
	return CString(szModuleName);
}


CString GetDirectory(HWND hWndParent, LPCTSTR szRoot, LPCTSTR szTitle)
{
	BROWSEINFO browseInfo;
	LPITEMIDLIST itemIDList;
	TCHAR	pathBuffer[MAX_PATH];
	TCHAR   displayName[MAX_PATH];
	
	browseInfo.hwndOwner		= hWndParent;
	browseInfo.pidlRoot			= NULL;
	browseInfo.pszDisplayName	= displayName;
	browseInfo.lpszTitle		= szTitle;
	browseInfo.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	browseInfo.lpfn				= NULL;
	browseInfo.lParam			= 0;
	
	// Show the dialog
	itemIDList = SHBrowseForFolder(&browseInfo);
	
	// Did user press cancel?
	if (!itemIDList) return _T("");
	
	// Get the path from the returned ITEMIDLIST
	if (!SHGetPathFromIDList(itemIDList, pathBuffer)) return _T("");
	
	// Now we need to free the ITEMIDLIST the shell allocated
	LPMALLOC	shellMalloc;
	HRESULT		hr;
	
	// Get pointer to the shell's malloc interface
	hr = SHGetMalloc(&shellMalloc);
	
	// Did it work?
	if (SUCCEEDED(hr)) 
	{
		// Free the shell's memory
		shellMalloc->Free(itemIDList);
		// Release the interface
		shellMalloc->Release();
	}
	return pathBuffer;
}

BOOL QueryShellFolders(TCHAR *name, TCHAR *out, HKEY hKey)
{
	BOOL ret=FALSE;
	if ( RegOpenKeyEx(hKey,_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders"),0,KEY_READ,&hKey) == ERROR_SUCCESS)
	{
		ULONG l = 1024;
		ULONG t=REG_SZ;
		if(RegQueryValueEx(hKey,name,NULL,&t,(BYTE*)out,&l)==ERROR_SUCCESS) ret=TRUE;
		RegCloseKey(hKey);
	}
	return ret;
}


CString	GetMyDocumentPath()
{
	TCHAR szPath[MAX_PATH];
	HKEY hKey = HKEY_CURRENT_USER;

	if(QueryShellFolders(_T("Common Documents"), szPath, hKey)==FALSE)		// ϸ Ʈ ˻ϰ.
	{
	 	if(QueryShellFolders(_T("Personal"), szPath, hKey)==FALSE)		//  
		{
		 	if(QueryShellFolders(_T("Personal"), szPath, HKEY_LOCAL_MACHINE)==FALSE)	//  
				lstrcpyn(szPath, GetThisPath(), MAX_PATH);
		}
	}

	return szPath;
}


CString WaveFormatTag2Str(WORD wFormatTag)
{
	CString s;
	switch(wFormatTag)
	{
	case 0x0000 : s = _T("UNKNOWN"); break;
	case 0x0001 : s = _T("PCM AUDIO(code 0x01)"); break;
	case 0x0002 : s = _T("ADPCM (Microsoft Corporation)"); break;
	case 0x0003 : s = _T("IEEE_FLOAT (Microsoft Corporation)"); break;
	case 0x0004 : s = _T("VSELP (Compaq Computer Corp.)"); break;
	case 0x0005 : s = _T("IBM_CVSD (IBM Corporation)"); break;
	case 0x0006 : s = _T("ALAW (Microsoft Corporation)"); break;
	case 0x0007 : s = _T("MULAW (Microsoft Corporation)"); break;
	case 0x0008 : s = _T("DTS (Microsoft Corporation)"); break;
	case 0x0009 : s = _T("DRM (Microsoft Corporation)"); break;
	case 0x0010 : s = _T("OKI_ADPCM (OKI)"); break;
	case 0x0011 : s = _T("DVI_ADPCM (Intel Corporation)"); break;
	case 0x0012 : s = _T("MEDIASPACE_ADPCM (Videologic)"); break;
	case 0x0013 : s = _T("SIERRA_ADPCM (Sierra Semiconductor Corp)"); break;
	case 0x0014 : s = _T("G723_ADPCM (Antex Electronics Corporation)"); break;
	case 0x0015 : s = _T("DIGISTD (DSP Solutions, Inc.)"); break;
	case 0x0016 : s = _T("DIGIFIX (DSP Solutions, Inc.)"); break;
	case 0x0017 : s = _T("DIALOGIC_OKI_ADPCM (Dialogic Corporation)"); break;
	case 0x0018 : s = _T("MEDIAVISION_ADPCM (Media Vision, Inc.)"); break;
	case 0x0019 : s = _T("CU_CODEC (Hewlett-Packard Company)"); break;
	case 0x0020 : s = _T("YAMAHA_ADPCM (Yamaha Corporation of America)"); break;
	case 0x0021 : s = _T("SONARC (Speech Compression)"); break;
	case 0x0022 : s = _T("DSPGROUP_TRUESPEECH (DSP Group, Inc)"); break;
	case 0x0023 : s = _T("ECHOSC1 (Echo Speech Corporation)"); break;
	case 0x0024 : s = _T("AUDIOFILE_AF36 (Virtual Music, Inc.)"); break;
	case 0x0025 : s = _T("APTX (Audio Processing Technology)"); break;
	case 0x0026 : s = _T("AUDIOFILE_AF10 (Virtual Music, Inc.)"); break;
	case 0x0027 : s = _T("PROSODY_1612 (Aculab plc)"); break;
	case 0x0028 : s = _T("LRC (Merging Technologies S.A.)"); break;
	case 0x0030 : s = _T("DOLBY_AC2 (Dolby Laboratories)"); break;
	case 0x0031 : s = _T("GSM610 (Microsoft Corporation)"); break;
	case 0x0032 : s = _T("MSNAUDIO (Microsoft Corporation)"); break;
	case 0x0033 : s = _T("ANTEX_ADPCME (Antex Electronics Corporation)"); break;
	case 0x0034 : s = _T("CONTROL_RES_VQLPC (Control Resources Limited)"); break;
	case 0x0035 : s = _T("DIGIREAL (DSP Solutions, Inc.)"); break;
	case 0x0036 : s = _T("DIGIADPCM (DSP Solutions, Inc.)"); break;
	case 0x0037 : s = _T("CONTROL_RES_CR10 (Control Resources Limited)"); break;
	case 0x0038 : s = _T("NMS_VBXADPCM (Natural MicroSystems)"); break;
	case 0x0039 : s = _T("CS_IMAADPCM (Crystal Semiconductor IMA ADPCM)"); break;
	case 0x003A : s = _T("ECHOSC3 (Echo Speech Corporation)"); break;
	case 0x003B : s = _T("ROCKWELL_ADPCM (Rockwell International)"); break;
	case 0x003C : s = _T("ROCKWELL_DIGITALK (Rockwell International)"); break;
	case 0x003D : s = _T("XEBEC (Xebec Multimedia Solutions Limited)"); break;
	case 0x0040 : s = _T("G721_ADPCM (Antex Electronics Corporation)"); break;
	case 0x0041 : s = _T("G728_CELP (Antex Electronics Corporation)"); break;
	case 0x0042 : s = _T("MSG723 (Microsoft Corporation)"); break;
	case 0x0050 : s = _T("MPEG (Microsoft Corporation)"); break;
	case 0x0052 : s = _T("RT24 (InSoft, Inc.)"); break;
	case 0x0053 : s = _T("PAC (InSoft, Inc.)"); break;
	case 0x0055 : s = _T("MP3"); break;
	case 0x0059 : s = _T("LUCENT_G723 (Lucent Technologies)"); break;
	case 0x0060 : s = _T("CIRRUS (Cirrus Logic)"); break;
	case 0x0061 : s = _T("ESPCM (ESS Technology)"); break;
	case 0x0062 : s = _T("VOXWARE (Voxware Inc)"); break;
	case 0x0063 : s = _T("CANOPUS_ATRAC (Canopus, co., Ltd.)"); break;
	case 0x0064 : s = _T("G726_ADPCM (APICOM)"); break;
	case 0x0065 : s = _T("G722_ADPCM (APICOM)"); break;
	case 0x0067 : s = _T("DSAT_DISPLAY (Microsoft Corporation)"); break;
	case 0x0069 : s = _T("VOXWARE_BYTE_ALIGNED (Voxware Inc)"); break;
	case 0x0070 : s = _T("VOXWARE_AC8 (Voxware Inc)"); break;
	case 0x0071 : s = _T("VOXWARE_AC10 (Voxware Inc)"); break;
	case 0x0072 : s = _T("VOXWARE_AC16 (Voxware Inc)"); break;
	case 0x0073 : s = _T("VOXWARE_AC20 (Voxware Inc)"); break;
	case 0x0074 : s = _T("VOXWARE_RT24 (Voxware Inc)"); break;
	case 0x0075 : s = _T("VOXWARE_RT29 (Voxware Inc)"); break;
	case 0x0076 : s = _T("VOXWARE_RT29HW (Voxware Inc)"); break;
	case 0x0077 : s = _T("VOXWARE_VR12 (Voxware Inc)"); break;
	case 0x0078 : s = _T("VOXWARE_VR18 (Voxware Inc)"); break;
	case 0x0079 : s = _T("VOXWARE_TQ40 (Voxware Inc)"); break;
	case 0x0080 : s = _T("SOFTSOUND (Softsound, Ltd.)"); break;
	case 0x0081 : s = _T("VOXWARE_TQ60 (Voxware Inc)"); break;
	case 0x0082 : s = _T("MSRT24 (Microsoft Corporation)"); break;
	case 0x0083 : s = _T("G729A (AT&T Labs, Inc.)"); break;
	case 0x0084 : s = _T("MVI_MVI2 (Motion Pixels)"); break;
	case 0x0085 : s = _T("DF_G726 (DataFusion Systems (Pty) (Ltd))"); break;
	case 0x0086 : s = _T("DF_GSM610 (DataFusion Systems (Pty) (Ltd))"); break;
	case 0x0088 : s = _T("ISIAUDIO (Iterated Systems, Inc.)"); break;
	case 0x0089 : s = _T("ONLIVE (OnLive! Technologies, Inc.)"); break;
	case 0x0091 : s = _T("SBC24 (Siemens Business Communications Sys)"); break;
	case 0x0092 : s = _T("DOLBY_AC3_SPDIF (Sonic Foundry)"); break;
	case 0x0093 : s = _T("MEDIASONIC_G723 (MediaSonic)"); break;
	case 0x0094 : s = _T("PROSODY_8KBPS (Aculab plc)"); break;
	case 0x0097 : s = _T("ZYXEL_ADPCM (ZyXEL Communications, Inc.)"); break;
	case 0x0098 : s = _T("PHILIPS_LPCBB (Philips Speech Processing)"); break;
	case 0x0099 : s = _T("PACKED (Studer Professional Audio AG)"); break;
	case 0x00A0 : s = _T("MALDEN_PHONYTALK (Malden Electronics Ltd.)"); break;
	case 0x0100 : s = _T("RHETOREX_ADPCM (Rhetorex Inc.)"); break;
	case 0x0101 : s = _T("IRAT (BeCubed Software Inc.)"); break;
	case 0x0111 : s = _T("VIVO_G723 (Vivo Software)"); break;
	case 0x0112 : s = _T("VIVO_SIREN (Vivo Software)"); break;
	case 0x0123 : s = _T("DIGITAL_G723 (Digital Equipment Corporation)"); break;
	case 0x0125 : s = _T("SANYO_LD_ADPCM (Sanyo Electric Co., Ltd.)"); break;
	case 0x0130 : s = _T("SIPROLAB_ACEPLNET (Sipro Lab Telecom Inc.)"); break;
	case 0x0131 : s = _T("SIPROLAB_ACELP4800 (Sipro Lab Telecom Inc.)"); break;
	case 0x0132 : s = _T("SIPROLAB_ACELP8V3 (Sipro Lab Telecom Inc.)"); break;
	case 0x0133 : s = _T("SIPROLAB_G729 (Sipro Lab Telecom Inc.)"); break;
	case 0x0134 : s = _T("SIPROLAB_G729A (Sipro Lab Telecom Inc.)"); break;
	case 0x0135 : s = _T("SIPROLAB_KELVIN (Sipro Lab Telecom Inc.)"); break;
	case 0x0140 : s = _T("G726ADPCM (Dictaphone Corporation)"); break;
	case 0x0150 : s = _T("QUALCOMM_PUREVOICE (Qualcomm, Inc.)"); break;
	case 0x0151 : s = _T("QUALCOMM_HALFRATE (Qualcomm, Inc.)"); break;
	case 0x0155 : s = _T("TUBGSM (Ring Zero Systems, Inc.)"); break;

	case 0x0160 : s = _T("MSAUDIO1 (Microsoft Corporation)"); break;		// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/wmform/htm/mediatypeidentifiers.asp
	case 0x0161 : s = _T("WMAudio V2/V7/V8 / DivX Audio"); break;
	case 0x0162 : s = _T("WMAudioV9 (Microsoft Corporation)"); break;
	case 0x0163 : s = _T("WMAudio_Lossless (Microsoft Corporation)"); break;

	case 0x0170 : s = _T("UNISYS_NAP_ADPCM (Unisys Corp.)"); break;
	case 0x0171 : s = _T("UNISYS_NAP_ULAW (Unisys Corp.)"); break;
	case 0x0172 : s = _T("UNISYS_NAP_ALAW (Unisys Corp.)"); break;
	case 0x0173 : s = _T("UNISYS_NAP_16K (Unisys Corp.)"); break;
	case 0x0200 : s = _T("CREATIVE_ADPCM (Creative Labs, Inc)"); break;
	case 0x0202 : s = _T("CREATIVE_FASTSPEECH8 (Creative Labs, Inc)"); break;
	case 0x0203 : s = _T("CREATIVE_FASTSPEECH10 (Creative Labs, Inc)"); break;
	case 0x0210 : s = _T("UHER_ADPCM (UHER informatic GmbH)"); break;
	case 0x0220 : s = _T("QUARTERDECK (Quarterdeck Corporation)"); break;
	case 0x0230 : s = _T("ILINK_VC (I-link Worldwide)"); break;
	case 0x0240 : s = _T("RAW_SPORT (Aureal Semiconductor)"); break;
	case 0x0241 : s = _T("ESST_AC3 (ESS Technology, Inc.)"); break;
	case 0x0250 : s = _T("IPI_HSX (Interactive Products, Inc.)"); break;
	case 0x0251 : s = _T("IPI_RPELP (Interactive Products, Inc.)"); break;
	case 0x0260 : s = _T("CS2 (Consistent Software)"); break;
	case 0x0270 : s = _T("SONY_SCX (Sony Corp.)"); break;
	case 0x0300 : s = _T("FM_TOWNS_SND (Fujitsu Corp.)"); break;
	case 0x0400 : s = _T("BTV_DIGITAL (Brooktree Corporation)"); break;

	case 0x0401 : s = _T("Intel Music Coder (IMC)"); break;

	case 0x0450 : s = _T("QDESIGN_MUSIC (QDesign Corporation)"); break;
	case 0x0680 : s = _T("VME_VMPCM (AT&T Labs, Inc.)"); break;
	case 0x0681 : s = _T("TPC (AT&T Labs, Inc.)"); break;
	case 0x1000 : s = _T("OLIGSM (Ing C. Olivetti & C., S.p.A.)"); break;
	case 0x1001 : s = _T("OLIADPCM (Ing C. Olivetti & C., S.p.A.)"); break;
	case 0x1002 : s = _T("OLICELP (Ing C. Olivetti & C., S.p.A.)"); break;
	case 0x1003 : s = _T("OLISBC (Ing C. Olivetti & C., S.p.A.)"); break;
	case 0x1004 : s = _T("OLIOPR (Ing C. Olivetti & C., S.p.A.)"); break;
	case 0x1100 : s = _T("LH_CODEC (Lernout & Hauspie)"); break;
	case 0x1400 : s = _T("NORRIS (Norris Communications, Inc.)"); break;
	case 0x1500 : s = _T("SOUNDSPACE_MUSICOMPRESS (AT&T Labs, Inc.)"); break;

	// ǥ?
	case 0x2000 : s = _T("AC3"); break;
	case 0x2001 : s = _T("DTS"); break;

	// OGG	
	case 0x674f	: s = _T("Ogg Vorbis - VORBIS_1"); break;
	case 0x6750	: s = _T("Ogg Vorbis - VORBIS_2"); break;
	case 0x6751	: s = _T("Ogg Vorbis - VORBIS_3"); break;
	case 0x676f	: s = _T("Ogg Vorbis - VORBIS_1_PLUS"); break;
	case 0x6770	: s = _T("Ogg Vorbis - VORBIS_2_PLUS"); break;
	case 0x6771	: s = _T("Ogg Vorbis - VORBIS_3_PLUS"); break;
	
	
	default :
		ASSERT(0);
		s.Format(_T("˼Unknown(code:0x%x)"), wFormatTag);
		break;
	}
	return s;
}


BOOL	IsKoreanOS()
{
	/*
#ifdef _DEBUG
	return FALSE;
#endif
	*/

	LANGID langID = GetUserDefaultLangID();

	if( (langID & 0xff) == LANG_KOREAN)
		return TRUE;
	return FALSE;
}


static int _MonthStr2Int(char* szMonth)
{
	char* str[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
	for(int i=0;i<12;i++) if(strncmp(str[i], szMonth, 3)==0) return i;
	return -1;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          带  ð ϱ
/// @return  
/// @date    2009-05-13 12:57:05
////////////////////////////////////////////////////////////////////////////////////////////////////
time_t GetBuildTime()
{
	CHAR buf[1024];
	CHAR szMonth[1024];
	struct tm when;
	memset(&when, 0, sizeof(tm));

	// DATE
	time_t buildtime;
	_snprintf_s(buf, 1024, 1024, "%s", __DATE__);
	sscanf_s(buf, "%s %d %d", szMonth, 1024, &(when.tm_mday), &(when.tm_year));		// , 
	when.tm_year -= 1900;	// 1900 base
	when.tm_mon = _MonthStr2Int(szMonth);									// 

	// TIME
	_snprintf_s(buf, 1024, 1024, "%s", __TIME__);
	sscanf_s(buf, "%d:%d:%d", &(when.tm_hour), &(when.tm_min), &(when.tm_sec));		// , 

	buildtime = mktime(&when);
	return buildtime;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
///           ð ڿ (: 2009/05/13)
/// @return  
/// @date    2009-05-13 12:57:08
////////////////////////////////////////////////////////////////////////////////////////////////////
CString GetBuildDateStr()
{
	
	CString sDate;
	time_t time = GetBuildTime();
	struct tm bt;
	errno_t error = localtime_s(&bt, &time);
	if(error == NULL)
		sDate.Format(_T("%04d/%02d/%02d"), bt.tm_year+1900, bt.tm_mon+1, bt.tm_mday);

	return sDate;
}


